package dev.shadowsoffire.apotheosis.ench.table;

package .tmp;

import dev.shadowsoffire.apotheosis.ench.table.ApothEnchantmentMenu;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingStatRegistry;
import java.util.Collections;
import java.util.HashSet;
import java.util.Set;
import net.minecraft.core.registries.BuiltInRegistries;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.util.Mth;
import net.minecraft.world.item.enchantment.Enchantment;

public final class TableStats extends Record {
  private final float eterna;
  
  private final float quanta;
  
  private final float arcana;
  
  private final float rectification;
  
  private final int clues;
  
  private final Set<Enchantment> blacklist;
  
  private final boolean treasure;
  
  public final String toString() {
    // Byte code:
    //   0: aload_0
    //   1: <illegal opcode> toString : (Ldev/shadowsoffire/apotheosis/ench/table/ApothEnchantmentMenu$TableStats;)Ljava/lang/String;
    //   6: areturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #359	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	7	0	this	Ldev/shadowsoffire/apotheosis/ench/table/ApothEnchantmentMenu$TableStats;
  }
  
  public final int hashCode() {
    // Byte code:
    //   0: aload_0
    //   1: <illegal opcode> hashCode : (Ldev/shadowsoffire/apotheosis/ench/table/ApothEnchantmentMenu$TableStats;)I
    //   6: ireturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #359	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	7	0	this	Ldev/shadowsoffire/apotheosis/ench/table/ApothEnchantmentMenu$TableStats;
  }
  
  public final boolean equals(Object o) {
    // Byte code:
    //   0: aload_0
    //   1: aload_1
    //   2: <illegal opcode> equals : (Ldev/shadowsoffire/apotheosis/ench/table/ApothEnchantmentMenu$TableStats;Ljava/lang/Object;)Z
    //   7: ireturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #359	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	8	0	this	Ldev/shadowsoffire/apotheosis/ench/table/ApothEnchantmentMenu$TableStats;
    //   0	8	1	o	Ljava/lang/Object;
  }
  
  public float eterna() {
    return this.eterna;
  }
  
  public float quanta() {
    return this.quanta;
  }
  
  public float arcana() {
    return this.arcana;
  }
  
  public float rectification() {
    return this.rectification;
  }
  
  public int clues() {
    return this.clues;
  }
  
  public Set<Enchantment> blacklist() {
    return this.blacklist;
  }
  
  public boolean treasure() {
    return this.treasure;
  }
  
  public static TableStats INVALID = new TableStats(0.0F, 0.0F, 0.0F, 0.0F, 0, Collections.emptySet(), false);
  
  public TableStats(float eterna, float quanta, float arcana, float rectification, int clues, Set<Enchantment> blacklist, boolean treasure) {
    this.eterna = Mth.m_14036_(eterna, 0.0F, EnchantingStatRegistry.getAbsoluteMaxEterna());
    this.quanta = Mth.m_14036_(quanta, 0.0F, 100.0F);
    this.arcana = Mth.m_14036_(arcana, 0.0F, 100.0F);
    this.rectification = Mth.m_14036_(rectification, 0.0F, 100.0F);
    this.clues = Math.max(clues, 0);
    this.blacklist = Collections.unmodifiableSet(blacklist);
    this.treasure = treasure;
  }
  
  public TableStats(float[] data, Set<Enchantment> blacklist, boolean treasure) {
    this(data[0], data[1], data[2], data[3], (int)data[4], blacklist, treasure);
  }
  
  public void write(FriendlyByteBuf buf) {
    buf.writeFloat(this.eterna);
    buf.writeFloat(this.quanta);
    buf.writeFloat(this.arcana);
    buf.writeFloat(this.rectification);
    buf.writeByte(this.clues);
    buf.writeShort(this.blacklist.size());
    for (Enchantment e : this.blacklist)
      buf.m_130130_(BuiltInRegistries.f_256876_.m_7447_(e)); 
    buf.writeBoolean(this.treasure);
  }
  
  public static TableStats read(FriendlyByteBuf buf) {
    float[] data = { buf.readFloat(), buf.readFloat(), buf.readFloat(), buf.readFloat(), buf.readByte() };
    int size = buf.readShort();
    Set<Enchantment> blacklist = new HashSet<>(size);
    for (int i = 0; i < size; i++)
      blacklist.add((Enchantment)BuiltInRegistries.f_256876_.m_7942_(buf.m_130242_())); 
    boolean treasure = buf.readBoolean();
    return new TableStats(data, blacklist, treasure);
  }
}
